Index: dna-repository/src/main/java/org/jboss/dna/repository/util/JcrExecutionContext.java
===================================================================
--- dna-repository/src/main/java/org/jboss/dna/repository/util/JcrExecutionContext.java	(revision 702)
+++ dna-repository/src/main/java/org/jboss/dna/repository/util/JcrExecutionContext.java	(working copy)
@@ -21,29 +21,103 @@
  */
 package org.jboss.dna.repository.util;
 
+import java.util.HashSet;
+import java.util.Set;
+import java.util.concurrent.atomic.AtomicBoolean;
+import javax.jcr.RepositoryException;
 import javax.jcr.Session;
 import org.jboss.dna.graph.ExecutionContext;
+import org.jboss.dna.repository.RepositoryI18n;
 
 /**
  * The context of an execution within a JCR environment.
  * 
  * @author Randall Hauch
  */
-public interface JcrExecutionContext extends ExecutionContext {
+public class JcrExecutionContext extends ExecutionContext {
 
+    private final String repositoryWorkspaceForNamespaceRegistry;
+    private final ClosableSessionFactory sessionFactory;
+    private final JcrTools jcrTools;
+
+    public JcrExecutionContext( ExecutionContext context,
+                                final SessionFactory sessionFactory,
+                                String repositoryWorkspaceForNamespaceRegistry ) {
+        super(context.with(new JcrNamespaceRegistry(sessionFactory, repositoryWorkspaceForNamespaceRegistry)));
+        this.sessionFactory = new ClosableSessionFactory(sessionFactory);
+        this.jcrTools = new JcrTools();
+        this.repositoryWorkspaceForNamespaceRegistry = repositoryWorkspaceForNamespaceRegistry;
+    }
+
+    public JcrExecutionContext( SessionFactory sessionFactory,
+                                String repositoryWorkspaceForNamespaceRegistry ) {
+        this(new ExecutionContext(), sessionFactory, repositoryWorkspaceForNamespaceRegistry);
+    }
+
     /**
      * Get the session factory, which can be used to obtain sessions temporarily for this context. Any session obtained from this
      * factory should be {@link Session#logout() closed} before the execution finishes.
      * 
      * @return the session factory
      */
-    SessionFactory getSessionFactory();
+    public SessionFactory getSessionFactory() {
+        return this.sessionFactory;
+    }
 
     /**
      * Get a set of utilities for working with JCR.
      * 
      * @return the tools
      */
-    JcrTools getTools();
+    public JcrTools getTools() {
+        return this.jcrTools;
+    }
 
+    /**
+     * {@inheritDoc}
+     * 
+     * @see org.jboss.dna.graph.ExecutionContext#clone()
+     */
+    @Override
+    public JcrExecutionContext clone() {
+        return new JcrExecutionContext(this, this.sessionFactory.getDelegateFactory(),
+                                       this.repositoryWorkspaceForNamespaceRegistry);
+    }
+
+    /**
+     * This this context and release all resources (including any Session instances created).
+     */
+    public void close() {
+        this.sessionFactory.close();
+    }
+
+    protected static class ClosableSessionFactory implements SessionFactory {
+        private final SessionFactory delegateFactory;
+        private final Set<Session> sessions = new HashSet<Session>();
+        protected final AtomicBoolean closed = new AtomicBoolean(false);
+
+        protected ClosableSessionFactory( SessionFactory sessionFactory ) {
+            this.delegateFactory = sessionFactory;
+        }
+
+        public SessionFactory getDelegateFactory() {
+            return this.delegateFactory;
+        }
+
+        public Session createSession( String name ) throws RepositoryException {
+            if (closed.get()) throw new IllegalStateException(RepositoryI18n.executionContextHasBeenClosed.text());
+            Session session = delegateFactory.createSession(name);
+            if (session != null) sessions.add(session);
+            return session;
+        }
+
+        public synchronized void close() {
+            if (this.closed.get()) return;
+            this.closed.set(true);
+            for (Session session : sessions) {
+                if (session != null) session.logout();
+            }
+        }
+    }
+
 }
Index: extensions/dna-sequencer-xml/src/main/java/org/jboss/dna/sequencer/xml/XmlSequencerHandler.java
===================================================================
--- extensions/dna-sequencer-xml/src/main/java/org/jboss/dna/sequencer/xml/XmlSequencerHandler.java	(revision 702)
+++ extensions/dna-sequencer-xml/src/main/java/org/jboss/dna/sequencer/xml/XmlSequencerHandler.java	(working copy)
@@ -31,7 +31,6 @@
 import org.jboss.dna.common.text.XmlNameEncoder;
 import org.jboss.dna.common.util.CheckArg;
 import org.jboss.dna.common.util.StringUtil;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.JcrLexicon;
 import org.jboss.dna.graph.properties.Name;
@@ -137,11 +136,11 @@
      * @param scoping
      */
     XmlSequencerHandler( SequencerOutput output,
-                                      SequencerContext context,
-                                      Name nameAttribute,
-                                      Name defaultPrimaryType,
-                                      TextDecoder textDecoder,
-                                      XmlSequencer.AttributeScoping scoping ) {
+                         SequencerContext context,
+                         Name nameAttribute,
+                         Name defaultPrimaryType,
+                         TextDecoder textDecoder,
+                         XmlSequencer.AttributeScoping scoping ) {
         CheckArg.isNotNull(output, "output");
         CheckArg.isNotNull(context, "context");
 
@@ -158,7 +157,7 @@
 
         // Set up a local namespace registry that is kept in sync with the namespaces found in this XML document ...
         NamespaceRegistry namespaceRegistry = new LocalNamespaceRegistry(this.context.getNamespaceRegistry());
-        final ExecutionContext localContext = new BasicExecutionContext(this.context, namespaceRegistry);
+        final ExecutionContext localContext = this.context.with(namespaceRegistry);
 
         // Set up references to frequently-used objects in the context ...
         this.nameFactory = localContext.getValueFactories().getNameFactory();
Index: extensions/dna-connector-jbosscache/src/test/java/org/jboss/dna/connector/jbosscache/JBossCacheConnectionTest.java
===================================================================
--- extensions/dna-connector-jbosscache/src/test/java/org/jboss/dna/connector/jbosscache/JBossCacheConnectionTest.java	(revision 702)
+++ extensions/dna-connector-jbosscache/src/test/java/org/jboss/dna/connector/jbosscache/JBossCacheConnectionTest.java	(working copy)
@@ -39,7 +39,6 @@
 import org.jboss.cache.DefaultCacheFactory;
 import org.jboss.cache.Fqn;
 import org.jboss.cache.Node;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.DnaLexicon;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.Graph;
@@ -80,7 +79,7 @@
     @Before
     public void beforeEach() throws Exception {
         MockitoAnnotations.initMocks(this);
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         context.getNamespaceRegistry().register(DnaLexicon.Namespace.PREFIX, DnaLexicon.Namespace.URI);
         pathFactory = context.getValueFactories().getPathFactory();
         propertyFactory = context.getPropertyFactory();
Index: extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/models/basic/ChildEntityTest.java
===================================================================
--- extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/models/basic/ChildEntityTest.java	(revision 702)
+++ extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/models/basic/ChildEntityTest.java	(working copy)
@@ -31,7 +31,6 @@
 import javax.persistence.Query;
 import org.hibernate.ejb.Ejb3Configuration;
 import org.jboss.dna.connector.store.jpa.models.common.NamespaceEntity;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.Path;
 import org.junit.After;
@@ -51,7 +50,7 @@
     @Before
     public void beforeEach() throws Exception {
         model = new BasicModel();
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         // Connect to the database ...
         Ejb3Configuration configurator = new Ejb3Configuration();
         model.configure(configurator);
Index: extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/models/basic/SubgraphQueryTest.java
===================================================================
--- extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/models/basic/SubgraphQueryTest.java	(revision 702)
+++ extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/models/basic/SubgraphQueryTest.java	(working copy)
@@ -43,7 +43,6 @@
 import org.jboss.dna.common.util.StringUtil;
 import org.jboss.dna.connector.store.jpa.models.common.NamespaceEntity;
 import org.jboss.dna.connector.store.jpa.util.Namespaces;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.Location;
 import org.jboss.dna.graph.properties.Name;
@@ -76,7 +75,7 @@
     @Before
     public void beforeEach() throws Exception {
         model = new BasicModel();
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
 
         // Load in the large value ...
         validLargeValues = new String[] {IoUtil.read(getClass().getClassLoader().getResourceAsStream("LoremIpsum1.txt")),
Index: extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/models/basic/BasicModelTest.java
===================================================================
--- extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/models/basic/BasicModelTest.java	(revision 702)
+++ extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/models/basic/BasicModelTest.java	(working copy)
@@ -39,7 +39,6 @@
 import org.jboss.dna.common.util.StringUtil;
 import org.jboss.dna.connector.store.jpa.JpaConnectorI18n;
 import org.jboss.dna.connector.store.jpa.models.common.NamespaceEntity;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.PropertyType;
 import org.jboss.dna.graph.requests.processor.RequestProcessor;
@@ -70,7 +69,7 @@
     @Before
     public void beforeEach() throws Exception {
         model = new BasicModel();
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
     }
 
     @After
Index: extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/util/SerializerTest.java
===================================================================
--- extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/util/SerializerTest.java	(revision 702)
+++ extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/util/SerializerTest.java	(working copy)
@@ -46,7 +46,6 @@
 import org.jboss.dna.common.util.SecureHash;
 import org.jboss.dna.common.util.StringUtil;
 import org.jboss.dna.connector.store.jpa.util.Serializer.ReferenceValues;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.Binary;
 import org.jboss.dna.graph.properties.Name;
@@ -72,7 +71,7 @@
 
     @Before
     public void beforeEach() {
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         propertyFactory = context.getPropertyFactory();
         valueFactories = context.getValueFactories();
         serializer = new Serializer(context, false);
Index: extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/util/RequestProcessorCacheTest.java
===================================================================
--- extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/util/RequestProcessorCacheTest.java	(revision 702)
+++ extensions/dna-connector-store-jpa/src/test/java/org/jboss/dna/connector/store/jpa/util/RequestProcessorCacheTest.java	(working copy)
@@ -29,7 +29,6 @@
 import java.util.LinkedList;
 import java.util.List;
 import java.util.UUID;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.Location;
 import org.jboss.dna.graph.properties.Name;
@@ -58,7 +57,7 @@
 
     @Before
     public void beforeEach() {
-        ExecutionContext context = new BasicExecutionContext();
+        ExecutionContext context = new ExecutionContext();
         pathFactory = context.getValueFactories().getPathFactory();
         nameFactory = context.getValueFactories().getNameFactory();
         namespaces = context.getNamespaceRegistry();
Index: extensions/dna-connector-svn/src/test/java/org/jboss/dna/connector/svn/SVNRepositoryConnectionTest.java
===================================================================
--- extensions/dna-connector-svn/src/test/java/org/jboss/dna/connector/svn/SVNRepositoryConnectionTest.java	(revision 702)
+++ extensions/dna-connector-svn/src/test/java/org/jboss/dna/connector/svn/SVNRepositoryConnectionTest.java	(working copy)
@@ -25,7 +25,6 @@
 import static org.hamcrest.core.IsNull.notNullValue;
 import static org.hamcrest.core.IsSame.sameInstance;
 import static org.jboss.dna.graph.IsNodeWithChildren.hasChild;
-import static org.jboss.dna.graph.IsNodeWithProperty.hasProperty;
 import static org.junit.Assert.assertThat;
 import static org.mockito.Mockito.mock;
 import java.io.File;
@@ -35,7 +34,6 @@
 import java.util.List;
 import org.jboss.dna.common.text.UrlEncoder;
 import org.jboss.dna.common.util.FileUtil;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.DnaLexicon;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.Graph;
@@ -61,10 +59,8 @@
 import org.junit.Test;
 import org.mockito.MockitoAnnotations;
 import org.mockito.MockitoAnnotations.Mock;
-import org.tmatesoft.svn.core.SVNException;
 import org.tmatesoft.svn.core.SVNNodeKind;
 import org.tmatesoft.svn.core.io.SVNRepository;
-import com.sun.org.apache.bcel.internal.generic.NEW;
 
 /**
  * @author Serge Pagop
@@ -90,7 +86,7 @@
     @Before
     public void beforeEach() throws Exception {
         MockitoAnnotations.initMocks(this);
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         context.getNamespaceRegistry().register(DnaLexicon.Namespace.PREFIX, DnaLexicon.Namespace.URI);
         context.getNamespaceRegistry().register(JcrLexicon.Namespace.PREFIX, JcrLexicon.Namespace.URI);
         context.getNamespaceRegistry().register(JcrNtLexicon.Namespace.PREFIX, JcrNtLexicon.Namespace.URI);
@@ -269,18 +265,16 @@
 
     @Test
     public void shouldAddAndDeleteChildUnderRootNode() throws Exception {
-        graph.batch().create("/nodeC")
-                       .with(propertyFactory().create(JcrLexicon.PRIMARY_TYPE, JcrNtLexicon.FOLDER))
-        .and(propertyFactory().create(JcrLexicon.CREATED,dateFactory().create(new Date()))).execute();
+        graph.batch().create("/nodeC").with(propertyFactory().create(JcrLexicon.PRIMARY_TYPE, JcrNtLexicon.FOLDER)).and(propertyFactory().create(JcrLexicon.CREATED,
+                                                                                                                                                 dateFactory().create(new Date()))).execute();
         // Now look up the root node ...
         Node root = graph.getNodeAt("/");
         assertThat(root, is(notNullValue()));
         assertThat(root.getChildren(), hasChild(child("nodeC")));
         SVNNodeKind nodeCKind = repository.checkPath("nodeC", -1);
         assertThat(nodeCKind, is(SVNNodeKind.DIR));
-        graph.batch().create("/nodeC/nodeC_1")
-                     .with(propertyFactory().create(JcrLexicon.PRIMARY_TYPE, JcrNtLexicon.FOLDER))
-                     .and(propertyFactory().create(JcrLexicon.CREATED,dateFactory().create(new Date()))).execute();
+        graph.batch().create("/nodeC/nodeC_1").with(propertyFactory().create(JcrLexicon.PRIMARY_TYPE, JcrNtLexicon.FOLDER)).and(propertyFactory().create(JcrLexicon.CREATED,
+                                                                                                                                                         dateFactory().create(new Date()))).execute();
         // Now look up the root node ...
         Node nodeC = graph.getNodeAt("/nodeC");
         assertThat(nodeC, is(notNullValue()));
@@ -290,7 +284,6 @@
 
     }
 
-
     protected Collection<String> containsPaths( Collection<Location> locations ) {
         List<String> paths = new ArrayList<String>();
         for (Location location : locations) {
Index: extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/merge/strategy/OneContributionMergeStrategyTest.java
===================================================================
--- extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/merge/strategy/OneContributionMergeStrategyTest.java	(revision 702)
+++ extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/merge/strategy/OneContributionMergeStrategyTest.java	(working copy)
@@ -34,7 +34,6 @@
 import org.jboss.dna.connector.federation.contribution.Contribution;
 import org.jboss.dna.connector.federation.merge.FederatedNode;
 import org.jboss.dna.connector.federation.merge.MergePlan;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.DnaLexicon;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.Location;
@@ -67,7 +66,7 @@
         strategy = new OneContributionMergeStrategy();
         contributions = new LinkedList<Contribution>();
         contributions.add(contribution);
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         context.getNamespaceRegistry().register("dna", "http://www.jboss.org/dna/something");
         context.getNamespaceRegistry().register("jcr", "http://www.jcr.org");
         parentPath = context.getValueFactories().getPathFactory().create("/a/b/c");
Index: extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/merge/strategy/SimpleMergeStrategyTest.java
===================================================================
--- extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/merge/strategy/SimpleMergeStrategyTest.java	(revision 702)
+++ extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/merge/strategy/SimpleMergeStrategyTest.java	(working copy)
@@ -38,7 +38,6 @@
 import org.jboss.dna.common.collection.IsIteratorContaining;
 import org.jboss.dna.connector.federation.contribution.Contribution;
 import org.jboss.dna.connector.federation.merge.FederatedNode;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.DnaLexicon;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.Location;
@@ -68,7 +67,7 @@
         MockitoAnnotations.initMocks(this);
         strategy = new SimpleMergeStrategy();
         contributions = new LinkedList<Contribution>();
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         context.getNamespaceRegistry().register("dna", "http://www.jboss.org/dna/something");
         context.getNamespaceRegistry().register("jcr", "http://www.jcr.org");
         parentPath = context.getValueFactories().getPathFactory().create("/a/b/c");
Index: extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/ProjectionPathRuleTest.java
===================================================================
--- extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/ProjectionPathRuleTest.java	(revision 702)
+++ extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/ProjectionPathRuleTest.java	(working copy)
@@ -28,7 +28,6 @@
 import static org.junit.matchers.JUnitMatchers.hasItems;
 import org.jboss.dna.common.text.TextEncoder;
 import org.jboss.dna.common.text.UrlEncoder;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.NamespaceRegistry;
 import org.jboss.dna.graph.properties.Path;
@@ -52,7 +51,7 @@
 
     @Before
     public void beforeEach() {
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         pathFactory = context.getValueFactories().getPathFactory();
         registry = context.getNamespaceRegistry();
         encoder = new UrlEncoder();
Index: extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/FederatedRepositoryTest.java
===================================================================
--- extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/FederatedRepositoryTest.java	(revision 702)
+++ extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/FederatedRepositoryTest.java	(working copy)
@@ -27,7 +27,6 @@
 import static org.hamcrest.core.IsSame.sameInstance;
 import static org.junit.Assert.assertThat;
 import static org.junit.matchers.JUnitMatchers.hasItems;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.connectors.RepositoryConnectionFactory;
 import org.jboss.dna.graph.connectors.RepositorySourceListener;
@@ -55,7 +54,7 @@
     @Before
     public void beforeEach() {
         MockitoAnnotations.initMocks(this);
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         repository = new FederatedRepository(context, connectionFactory, config);
     }
 
Index: extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/FederatedRepositorySourceTest.java
===================================================================
--- extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/FederatedRepositorySourceTest.java	(revision 702)
+++ extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/FederatedRepositorySourceTest.java	(working copy)
@@ -40,7 +40,6 @@
 import javax.naming.spi.ObjectFactory;
 import javax.security.auth.callback.CallbackHandler;
 import javax.security.auth.login.LoginException;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.DnaLexicon;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.ExecutionContextFactory;
@@ -88,7 +87,7 @@
     @Before
     public void beforeEach() throws Exception {
         MockitoAnnotations.initMocks(this);
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         context.getNamespaceRegistry().register(DnaLexicon.Namespace.PREFIX, DnaLexicon.Namespace.URI);
         configurationSourceName = "configuration source name";
         repositoryName = "Test Repository";
Index: extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/FederatedRepositorySourceIntegrationTest.java
===================================================================
--- extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/FederatedRepositorySourceIntegrationTest.java	(revision 702)
+++ extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/FederatedRepositorySourceIntegrationTest.java	(working copy)
@@ -36,7 +36,6 @@
 import java.util.List;
 import javax.naming.Context;
 import javax.security.auth.callback.CallbackHandler;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.DnaLexicon;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.ExecutionContextFactory;
@@ -101,7 +100,7 @@
         MockitoAnnotations.initMocks(this);
 
         // Set up the environment (ExecutionContext, JNDI, security, etc.)
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         context.getNamespaceRegistry().register(DnaLexicon.Namespace.PREFIX, DnaLexicon.Namespace.URI);
         executionContextFactoryJndiName = "context factory jndi name";
         repositoryConnectionFactoryJndiName = "repository connection factory jndi name";
Index: extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/ProjectionTest.java
===================================================================
--- extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/ProjectionTest.java	(revision 702)
+++ extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/ProjectionTest.java	(working copy)
@@ -28,7 +28,6 @@
 import static org.junit.matchers.JUnitMatchers.hasItems;
 import static org.mockito.Mockito.stub;
 import java.util.Set;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.properties.Path;
 import org.jboss.dna.graph.properties.PathFactory;
@@ -57,7 +56,7 @@
     @Before
     public void beforeEach() {
         MockitoAnnotations.initMocks(this);
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         pathFactory = context.getValueFactories().getPathFactory();
         sourceName = "Valid name";
         rules = new Projection.Rule[] {mockRule1, mockRule2, mockRule3};
Index: extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/executor/FederatingCommandExecutorTest.java
===================================================================
--- extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/executor/FederatingCommandExecutorTest.java	(revision 702)
+++ extensions/dna-connector-federation/src/test/java/org/jboss/dna/connector/federation/executor/FederatingCommandExecutorTest.java	(working copy)
@@ -41,7 +41,6 @@
 import org.jboss.dna.connector.federation.Projection;
 import org.jboss.dna.connector.federation.ProjectionParser;
 import org.jboss.dna.connector.federation.contribution.Contribution;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.Location;
 import org.jboss.dna.graph.cache.BasicCachePolicy;
@@ -82,7 +81,7 @@
     @Before
     public void beforeEach() throws Exception {
         MockitoAnnotations.initMocks(this);
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         pathFactory = context.getValueFactories().getPathFactory();
         sourceName = "Federated Source";
         cachePolicy = new BasicCachePolicy(10L, TimeUnit.SECONDS);
Index: dna-graph/src/test/java/org/jboss/dna/graph/xml/XmlHandlerTest.java
===================================================================
--- dna-graph/src/test/java/org/jboss/dna/graph/xml/XmlHandlerTest.java	(revision 702)
+++ dna-graph/src/test/java/org/jboss/dna/graph/xml/XmlHandlerTest.java	(working copy)
@@ -35,7 +35,6 @@
 import java.util.Map;
 import org.jboss.dna.common.text.Jsr283Encoder;
 import org.jboss.dna.common.text.TextDecoder;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.JcrLexicon;
 import org.jboss.dna.graph.Location;
@@ -73,7 +72,7 @@
 
     @Before
     public void beforeEach() {
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         context.getNamespaceRegistry().register(JcrLexicon.Namespace.PREFIX, JcrLexicon.Namespace.URI);
         context.getNamespaceRegistry().register("nt", NT_NAMESPACE_URI);
         destination = new RecordingDestination();
Index: dna-graph/src/test/java/org/jboss/dna/graph/GraphTest.java
===================================================================
--- dna-graph/src/test/java/org/jboss/dna/graph/GraphTest.java	(revision 702)
+++ dna-graph/src/test/java/org/jboss/dna/graph/GraphTest.java	(working copy)
@@ -101,7 +101,7 @@
         MockitoAnnotations.initMocks(this);
         executedRequests = new LinkedList<Request>();
         sourceName = "Source";
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         connection = new MockRepositoryConnection();
         stub(connectionFactory.createConnection(sourceName)).toReturn(connection);
         graph = new Graph(sourceName, connectionFactory, context);
Index: dna-graph/src/test/java/org/jboss/dna/graph/GraphImporterTest.java
===================================================================
--- dna-graph/src/test/java/org/jboss/dna/graph/GraphImporterTest.java	(revision 702)
+++ dna-graph/src/test/java/org/jboss/dna/graph/GraphImporterTest.java	(working copy)
@@ -70,7 +70,7 @@
     public void beforeEach() throws Exception {
         MockitoAnnotations.initMocks(this);
         xmlContent = new File("src/test/resources/repositoryImporterTestData1.xml").toURI();
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         context.getNamespaceRegistry().register(DnaLexicon.Namespace.PREFIX, DnaLexicon.Namespace.URI);
         context.getNamespaceRegistry().register("jcr", "http://www.jcp.org/jcr/1.0");
         context.getNamespaceRegistry().register("nt", "http://www.jcp.org/jcr/nt/1.0");
Index: dna-graph/src/test/java/org/jboss/dna/graph/requests/AbstractRequestTest.java
===================================================================
--- dna-graph/src/test/java/org/jboss/dna/graph/requests/AbstractRequestTest.java	(revision 702)
+++ dna-graph/src/test/java/org/jboss/dna/graph/requests/AbstractRequestTest.java	(working copy)
@@ -24,7 +24,6 @@
 import static org.hamcrest.core.Is.is;
 import static org.junit.Assert.assertThat;
 import java.util.UUID;
-import org.jboss.dna.graph.BasicExecutionContext;
 import org.jboss.dna.graph.ExecutionContext;
 import org.jboss.dna.graph.Location;
 import org.jboss.dna.graph.properties.Name;
@@ -53,7 +52,7 @@
 
     @Before
     public void beforeEach() {
-        context = new BasicExecutionContext();
+        context = new ExecutionContext();
         Path validPath = createPath("/a/b/c");
         UUID validUuid = UUID.randomUUID();
         Name idProperty1Name = createName("id1");
